---
layout: markdown_page
title: "Category Direction - Source Code Management"
description: "Source Code Management provides the core workflows and controls for teams to collaborate using Git to build great software. Find more information here!"
canonical_path: "/direction/create/source_code_management/"
---

- TOC
{:toc}

## Source Code Management

**Last updated**: 2021-05-05

| Section | Stage | Maturity | Last Reviewed |
| --- | --- | --- | --- |
| [Dev](/direction/dev/) | [Create](https://about.gitlab.com/stages-devops-lifecycle/create/) | [Loveable](/direction/maturity/) | 2021-11-12 |

## Introduction and how you can help

The Source Code Management direction page belongs to the [Source Code](/handbook/product/categories/#source-code-group) group of the [Create](/stages-devops-lifecycle/create/) stage,
and is maintained by [Sarah Waldner](https://gitlab.com/sarahwaldner), who can be reached at swaldner@gitlab.com.

This direction is a work in progress, and everyone can contribute.
Please comment and contribute in the linked issues and epics.
Sharing your feedback directly on GitLab.com is the best way to contribute to our strategy and vision.

- [Issue List](https://gitlab.com/groups/gitlab-org/-/issues?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Asource%20code)
- [Epic List](https://gitlab.com/groups/gitlab-org/-/epics?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Asource%20code)

## Overview

Source Code Management provides the core workflows and controls for teams to collaborate using Git to build great software,
including repository view, protected branches, code owners, merge request approvals, and mirroring.

### Performance indicators

The primary performance indicator (PI) for our group is the [number of unique users writing to a project Git repository](https://about.gitlab.com/handbook/product/dev-section-performance-indicators/#createsource-code---gmau---unique-users-writing-to-a-project-git-repository). We want to ensure all the features in our group provide a great experience that ultimately will allow everyone to contribute more often. A great experience in our group is a critical starting point for this.

<embed width="100%" height="400px" src="<%= signed_periscope_url(chart: 11616492, dashboard: 858264, embed: 'v2') %>"> 

Aligning with our SaaS first and product depth direction, we are also working to make performance our secondary indicator (see [related issue](https://gitlab.com/gitlab-org/gitlab/-/issues/327659 )). The intent here is to track the most heavily used services in our group and track how they improve over time. We firmly believe [speed is the killer feature](https://bdickason.com/posts/speed-is-the-killer-feature) and as such will work to provide a speedy experience to set a great stage for new and existing users.

See more detail in the [Create:Source Code PI page section](https://about.gitlab.com/handbook/product/dev-section-performance-indicators/#createsource-code-secondary---other---gitlabcom-performance-scores).

<!-- TODO: public chart visualizing performance (ie Grafana chart) -->

### Target Audience

Source code management targets mainly software engineers but also anyone who is contributing to any types of project. To that end, we target all the [user personas](/handbook/marketing/strategic-marketing/roles-personas/#user-personas) we describe in our handbook, with a special focus on the following:

- **[Sasha (Software Developer):](/handbook/marketing/strategic-marketing/roles-personas/#sasha-software-developer)** targets full time contributors to all types of projects (commercial, OSS, data science, etc.). These users expect and need a high level of reliability and speed in their interactions with both project files and Git.

- **[Delaney (Development Team Lead):](/handbook/marketing/strategic-marketing/roles-personas/#delaney-development-team-lead)** targets users who often times have elevated roles which allow for the management of project settings, such as access control, security, commit strategies, and mirroring.

- **[Devon (DevOps Engineer):](/handbook/marketing/strategic-marketing/roles-personas/#devon-devops-engineer)** targets engineers tasked with supporting and enabling software teams. Their tasks often revolve around platform creation and maintenance, where [GitOps](/topics/gitops/)] workflows are crucial.

### User journeys

The Source Code Management category is expansive and encompasses a broad set of features. Which features are leveraged, how they are leveraged, and to what extent greatly depends on the size of development team and the complexity of the product that they are building. We find that as the team size grows, as does the complexity of the software product. For these reasons, it is challenging to define a single user journey that captures how our users move through Source Code. That being said, there are five main buckets we can use to group the jobs to be done of our users. Understanding this general workflow helps to focus product development and discovery when exploring how to streamline the Source Code experience

![image.png](./source_code_user_journey.png)

We intend to define and document the user journeys our specific personas take and how those differ based on the size of the development and the industry in which they work.

<%= partial("direction/create/includes/_connection-source-code-management-and-code-review.erb") %>

<!--
### Challenges to address

- What needs, goals, or jobs to be done do the users have?
- How do users address these challenges today? What products or work-arounds are utilized?

Provide links to UX Research issues, which validate these problems exist.
-->

## Where we are Headed

<!--
Describe the future state for your category.
- What problems are we intending to solve?
- How will GitLab uniquely address them?
- What is the resulting benefits and value to users and their organizations?

Use narrative techniques to paint a picture of how the lives of your users will benefit from using this category once your strategy is at least minimally realized.
-->

Building great software depends on teams working well together.
Teams can rarely be divided into areas of complete independence.
As cross-functional security, compliance and growth teams are formed,
or new services and libraries are created,
effective coordination and collaboration is a must.
This is true whether using a single monolithic repository,
or spread across numerous smaller services and libraries.

Teams require the controls to protect production while making it easy for everyone contribute.
This means providing more granular and dynamic controls so that low risk changes can be made easily, and only the highest risk changes require the strictest controls.

When building software, teams greatly benefit from using open-source projects and may even submit contributions upstream. However, the balance of contribution vs. consumption is askew, partly because of a lack of controlled upstream workflows. Particularly from closed projects.

Upstreaming contributions from private repositories to a public upstream should be simple and safe, even for conservative organizations. Whether the upstream repository is on the same GitLab server, is hosted on GitHub.com, or managed via a mailing list.

Monolithic repositories, more commonly known as monorepos, are a software development approach where code for many projects is stored in a single repository. Monorepos provide a number of advantages such as reduced complexity, code reuse, easier collaboration amongst teams, and streamlined dependency management. Additionally, there are several drawbacks such as difficult to scale, performance concerns, requires large amounts of storage, and loss of per-service semantic versioning. Working with monorepos in Git and in GitLab should be efficient.

### Critical Product Principles

GitLab maintains a set of [Product Principles](https://about.gitlab.com/handbook/product/product-principles/),
some of which are more critical to be aware of in the
Source Code category. Here they are, and why the are critical:
- [Convention over Configuration](https://about.gitlab.com/handbook/product/product-principles/#convention-over-configuration):
Configuring how code is accessed, protected, contributed, and presented varies greatly among software teams.
Striking a balanced set of defaults for new and existing features is paramount to enabling productive teams.
- [Parity between SaaS and Self-managed deployments](https://about.gitlab.com/handbook/product/product-principles/#parity-between-saas-and-self-managed-deployments): Software teams set contribution policies either
globally (enterprise) or by enabling each team to decide what's best for them (OSS, startups). Source Code features
must be flexible enough to serve teams of all sizes, regardless of their environment.
- [Simplicity](https://about.gitlab.com/handbook/product/product-principles/#simplicity): As we add more features,
it's important for users to keep the focus on the applications they are building. We don't want to make users think.
- [Minimum Viable Change (MVC)](https://about.gitlab.com/handbook/product/product-principles/#the-minimal-viable-change-mvc):
The SCM space is an endless source of use-cases and problems that arise from every different style, team type, use-case, etc.
After we've validated a problem, we'll try to solve it with the smallest possible solution and iterate from there.


### What we recently shipped

For 2021 we placed special emphasis on strengthening our [SaaS offering](https://about.gitlab.com/direction/#saas-first) by focusing on ensuring feature parity with our market leading self-managed offering. For the Source Code group, this that meant delivering solutions that are scalable, performant, and secure. For the last 6 months we've been focused on: 

- [Performance](https://gitlab.com/groups/gitlab-org/-/issues?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Asource%20code&label_name[]=performance): Ensure GitLab.com performs well at scale as well as provides a great developer experience on key workflows and actions. Focus on resolving existing failure scenarios and technical debt.

- [Infradev](https://gitlab.com/groups/gitlab-org/-/issues?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Asource%20code&label_name[]=infradev): Protect GitLab.com's availability from infrastructure failure.

### What we are currently working on

We are immediately focused on improving the [security](https://gitlab.com/groups/gitlab-org/-/issues?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Asource%20code&label_name[]=security) posture of GitLab.com. 

Our intention is to kick-off FY23 from a performant and reliable platform with a great security posture.

### What's Next & Why

We are currently exploring the following opportunities to pursue in FY23.

#### [Git for enourmous repositories](https://gitlab.com/groups/gitlab-org/-/epics/773)

Monolithic repositories, more commonly known as monorepos, are a software development approach where code for many projects is stored in a single repository. Monorepos provide a number of advantages such as reduced complexity, code reuse, easier collaboration amongst teams, and streamlined dependency management. Additionally, there are several drawbacks such as difficult to scale, performance concerns, requires large amounts of storage, and loss of per-service semantic versioning. We have the opportunity to improve monorepo workflows via improvements to partial clone and sparse checkout.

#### [Cost saving initiatives](https://gitlab.com/groups/gitlab-com/-/epics/1629)

There is a lot of opportunity for Source Code to optimize resource consumption in CI as well as storage costs.

#### [Framework for Source Code Rules](https://gitlab.com/groups/gitlab-org/-/epics/6351)

GitLab offers a number of controls that can be implemented as safeguards. These controls can be put in place to keep changes from having a negative or enforce adherence to policies. Integrating features like protected branches, approval rules, code owners (approvals) and soon “status checks” should have an experience that easy to set up, maintain, and consume downstream.

#### Improvements to [Code owners](https://gitlab.com/groups/gitlab-org/-/epics/5886) and [protected branches](https://gitlab.com/groups/gitlab-org/-/epics/522)

Large organizations with many projects and large projects need to enforce review policies so that they can ensure the correct teams and individuals review changes that impact them. File owners will be automatically added to related Merge Requests (separate feature), but it is also necessary to add controls to prevent changes directly to important branches without approval.
We should continue to improve on the [first iteration of code owners]( https://gitlab.com/groups/gitlab-org/-/epics/77).

### What is Not Planned Right Now

The Source Code group is not investing in the following opportunities in the immediate future:

- [Branch read access controls](https://gitlab.com/gitlab-org/gitlab-ee/issues/720)

    Limiting which branches a user can read in a Git repository is possible in a basic sense,
    by only advertising a subset of refs,
    but it is not possible to guarantee that unreachable objects will not be sent to the client.
    This means that branch read access controls would be very weak,
    since they could not prevent exfiltration of data they do not have permission to read.

- Path-level read access controls

    From a commit, Git expects all trees and blobs to be reachable.
    Although Git supports partial clone and spares checkout,
    which allow data to be excluded from fetch and checkout,
    Git expects to be able to fetch missing objects on demand.
    Deliberately excluding objects by path is likely to cause unexpected failures.

### Maturity Plan

<!--
It's important your users know where you're headed next.
The maturity plan section captures this by showing what's required to achieve the next level.
-->

This category is currently at the **Loveable** maturity level (see our [definitions of maturity levels](https://about.gitlab.com/direction/maturity/)).

However, specific aspects are not yet loveable:

- [Forking](https://gitlab.com/groups/gitlab-org/-/epics/264)
- [Mirroring](https://gitlab.com/groups/gitlab-org/-/epics/852)

## Competitive Landscape

<!--
Lost the top two or three competitors.
What the next one or two items we should work on to displace the competitor at customers?
Ideally these should be discovered through [customer meetings](/handbook/product/product-processes/#customer-meetings).

We’re not aiming for feature parity with competitors,
and we’re not just looking at the features competitors talk about,
but we’re talking with customers about what they actually use,
and ultimately what they need.
-->

Important competitors are [GitHub](https://github.com) and [Perforce](https://perforce.com),
and increasingly [Azure DevOps](https://docs.microsoft.com/en-us/azure/devops/user-guide/alm-devops-features).

For public open source projects, GitHub is our primary competitor,
with millions of active users having chosen GitHub before the first version of GitLab ever existed.

In most source code management capabilities GitLab compares favorably to GitHub,
the most notable exception being the maturity of forking workflows which GitHub pioneered.
GitHub has a highly polished and fast product,
which makes tasks like browsing and managing projects fast and easy.

- [Make forking loveable](https://gitlab.com/groups/gitlab-org/-/epics/264)

For users of [SVN (Apache Subversion)](https://subversion.apache.org/) intending to migrate to Git,
GitHub is a significant competitor, particularly because GitHub supports hosting SVN repositories.

[Perforce](https://perforce.com) competes with GitLab primarily on its ability to support enormous repositories,
however, Perforce also competes on the basis of being a Centralized Version Control System.
This means that Perforce not only supports granular write permissions,
but granular read permissions on a branch and file path basis.
While fine grained read permissions are important to some customers,
large monolithic repositories may be split into smaller repositories allowing read controls and easier management.

- [Git for enormous repositories](https://gitlab.com/groups/gitlab-org/-/epics/773)

## Analyst Landscape

<!--
What are analysts and/or thought leaders in the space talking about?
What are one or two issues that will help us stay relevant from their perspective?
-->

Large file support (see [Gitaly direction](/direction/create/gitaly/)) is an ongoing area of interest because it blocks certain segments of software development from using Git.

Similarly extremely large repository support (see [Gitaly direction](/direction/create/gitaly/)) is also an area of interest for the same reason.

## Top Customer Success/Sales issue(s)

<!--
These can be sourced from the CS/Sales top issue labels when available,
internal surveys, or from your conversations with them.
-->

The most frequent category of request is for improved support for finer grained controls,
so that policies can be enforced at key points in the workflow,
and more permissive permissions can be granted at other times.

- Support for very large repositories (see [Gitaly direction](/direction/create/gitaly/)), requested particularly by customers migrating from a Centralized Version Control System.
- [Improved support for forking workflows](https://gitlab.com/groups/gitlab-org/-/epics/264), which is important for customers large and small, commercial and open source.

## Top user issue(s)

<!--
This is probably the top popular issue from the category (i.e. the one with the most thumbs-up),
but you may have a different item coming out of customer calls.
-->

- [Automatically create tag when merging](https://gitlab.com/gitlab-org/gitlab/-/issues/15962)
- [Clone statistics](https://gitlab.com/gitlab-org/gitlab/-/issues/15807)

## Top dogfooding issues

<!--
These are sourced from internal customers wanting to [dogfood](/handbook/values/#dogfooding) the product.
-->

- [Subscribe to code changes](https://gitlab.com/gitlab-org/gitlab/-/issues/1817)

## Top Vision Item(s)

<!--
What's the most important thing to move your vision forward?
-->

- Support for monolithic repositories (see [Gitaly direction](/direction/create/gitaly/))
- [🎨 Improve file locking for binary asset workflows](https://gitlab.com/groups/gitlab-org/-/epics/1488)
- [Support multiple code owner files](https://gitlab.com/groups/gitlab-org/-/epics/306)
